require 'mpath_graph'
require 'minitest/autorun'
require 'minitest/unit'

# Author::    Israel Buitron  (mailto:ibuitron@computacion.cs.cinvestav.mx)
class TestMPathGraph < MiniTest::Unit::TestCase

  def setup
  end

  def test_gen_mpath_graph_from_paths
    paths = [[1,2,3,4],[5,6,7,8],[0,1,8,4]]

    assert_equal [[0,2],[1,2]], MPathGraph::gen_mpath_graph_from_paths(paths)
  end

  def test_share_inner_vertices
    assert_raises(ArgumentError) {MPathGraph::share_inner_vertices?([],[1])}

    refute MPathGraph::share_inner_vertices?([1,2,3,4,5,6],[0,7,8,9,10,11])
    refute MPathGraph::share_inner_vertices?([1,2,3,4,5,6],[1,7,8,9,10,11])
    assert MPathGraph::share_inner_vertices?([1,2,3,4,5,6],[0,1,8,9,10,11])
    assert MPathGraph::share_inner_vertices?([1,2,3,4,5,6],[2,7,8,9,10,11])
    assert MPathGraph::share_inner_vertices?([1,2,3,4,5,6],[6,7,8,4,9,0])
  end
end
